/*******************************************************************************
* Implementa uso de Timers: Timer2 y SysTick (timer de sistema)
* Este proyecto se cre utilizando New->C Project -> Embedded C Project y
* eligiendo el micro STM32F103C8. Luego se limpi la plantilla. De este modo
* quedan incluidas las funciones de inicializacin de clock de micro.
* (ver archivo system_stm32f10x.c) y se incluye la biblioteca de perifricos
* de CMSIS
* Se utiliza adems un driver de timers propio (parcialmente implementado)
******************************************************************************/

#include "stm32f10x.h"
#include <stdint.h>
#include "MyEP_STM32F103_TIMERS.h" //

uint32_t Ciclos;
int main(void)
{
   SystemInit(); // Configura PLL etc
//1--- Para usar interrupcion de SysTick (si no no es necesario)--
	SystemCoreClockUpdate();  // toma frecuencia de clk de sistema en SystemCoreClock
	#ifndef __NO_SYSTICK
	  SysTick_Config(SystemCoreClock /1000);        // SysTick 1 msec irq
	#endif
//1---------------------------------------------------------------
//2 Inicializacin de pin utilizando funciones provistas (parar cursor sobre
// funcin para ver modo de uso

		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
		GPIO_InitTypeDef PINs_Init;	// Estructura tipo GPIO_Init...
		PINs_Init.GPIO_Pin = GPIO_Pin_13;
		PINs_Init.GPIO_Speed = GPIO_Speed_2MHz; //ir a definicin de tipos (F3) para ver valores posibles
		PINs_Init.GPIO_Mode = GPIO_Mode_Out_PP;
		GPIO_Init(GPIOC, &PINs_Init);

//		  RCC->APB2ENR |= (1<<4);	// Habilita clock de GPIOC
//		  GPIOC->CRH=(3<<20); 		//Hace MODE13 =3 (output 50MHz) y CNF13=0 (GPIO)
		  	  	  	  	  	  	  	// ver seccin 9.2.2 de manual
//2--
Ciclos = 0;
uint16_t prescaler=36000;
uint16_t periodo=100;
  TIMER_init(2,prescaler,periodo); //TIM2: 36MHz/36000(prescaler)=1000Hz/100(periodo) = 10Hz
  TIMER_interrupt_Enable(2, TIM_IT_Update); // Habilita interrupcin por desborde de Timer1
uint16_t i;
  while (1)
  {
	  i++;
  }
}
void TIM2_IRQHandler(void)  // Desborde de Timer 2,
{
	if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET) //Verifica que el evento es TIM_IT_Update
	{
		TIM_ClearITPendingBit(TIM2, TIM_IT_Update); // Borra flag de interrupcin
		GPIOC->ODR^=(1<<13);						// Conmuta GPIO13
	}
}

void SysTick_Handler(void) 		//Handler de SysTick
{
  Ciclos++;
}

