/*
******************************************************************************
Ej00_STM32F103C8_noH
Muestra el manejo directo de registros utilizando definiciones bsicas
MyEP 2019
El acceso a los registros se realiza definiendo punteros a sus direcciones
obtenidas del manual de Referencia de la familia STM32F10x:
http://bit.ly/2W4Wplq

******************************************************************************
*/

#include <stdint.h>		// para uso de uint32_t

#define GPIOC_BASE 				0x40011000
#define RCC_BASE				0x40021000	//Base del regitro Reset & Clock Contro
#define RCC_APB2ENR				((uint32_t *)(RCC_BASE+0x018)) // Para habilitar el clock del puente APB2, donde est GPIOC
#define GPIOC_CRL				((uint32_t *)(GPIOC_BASE+0x00)) // Configuracin de pines 0 a 7 de GPIOC
#define GPIOC_CRH				((uint32_t *)(GPIOC_BASE+0x04)) // Configuracin de pines 8 a 15 de GPIOC
#define GPIOC_ODR				((uint32_t *)(GPIOC_BASE+0x0C)) // GPIOC Output Data Register

int main(void)
{
  uint32_t T = 0;
  *RCC_APB2ENR |= (1<<4);	// Habilita clock de GPIOC
  *GPIOC_CRH=(3<<20); 		//Hace MODE13 =3 (output 50MHz) y CNF13=0 (GPIO)
  	  	  	  	  	  	  	// ver seccin 9.2.2 de manual
  while (1)
  {
	  *GPIOC_ODR&=~(1<<13);		// Pone en 0 GPIOC13 (enciende LED de placa)
	  T=500000;
	  while(T--);
	  *GPIOC_ODR|=1<<13;		// Pone en 1 GPIOC13 (apaga LED de placa)
	  T=2500000;
	  while(T--);
  }
}
