/*
******************************************************************************
Ej01_STM32F103C8_H
Muestra el manejo de registros utilizando las estructuras definidas en
la cabecera stm32f10x.h de CMSIS
El acceso a los registros del perifrico se realiza escribiendo el nombre
del perifrico (que es un puntero a una estructura) y con -> el nombre del
registro de dicho perifrico.
******************************************************************************
*/
#include <stddef.h>
#include "stm32f10x.h"


int main(void)
{
  uint32_t T = 0;
  RCC->APB2ENR |= (1<<4); // Habilita clock de GPIOC (Registro APB2ENR de perifrico RCC
  GPIOC->CRH=(3<<20); 	  //Hace MODE13 =3 (output 50MHz) y CNF13=0 (GPIO)
  	  	  	  	  	  	  // Ver seccin 9.2.2 de manual http://bit.ly/2W4Wplq

  while (1)
  {
	  //GPIOC->ODR&=~(1<<13); // Pone en 0 GPIOC13 (ver seccin 9.2.4 de manual http://bit.ly/2W4Wplq
	  GPIOC->BSRR=1<<(13+16);
	  T=1000000;
	  while(T--);
	  //GPIOC->ODR|=1<<13;
	  GPIOC->BSRR=1<<13;
	  T=5000000;
	  while(T--);
  }
}

