
/*MyEP_STM32F4_TIMERS
 * Funciones para inicializar los timers y habilitar interrupciones de timer
 * completa para timers 1 y 2
 * MyEP 2016
 */


#include <MyEP_STM32F103_TIMERS.h>

#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_tim.h"
#include "misc.h"

void TIMER_init(int timer,int prescaler,int periodo)
{
	TIM_TimeBaseInitTypeDef timerInitStructure;
	switch(timer)
		{
		case 1:		
			RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE);
			timerInitStructure.TIM_Prescaler = prescaler;
			timerInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
			timerInitStructure.TIM_Period = periodo;
			timerInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
			timerInitStructure.TIM_RepetitionCounter = 0;
			TIM_TimeBaseInit(TIM1, &timerInitStructure);
			TIM_Cmd(TIM1, ENABLE);
		break;
		case 2:		
			RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);
			timerInitStructure.TIM_Prescaler = prescaler;
			timerInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
			timerInitStructure.TIM_Period = periodo;
			timerInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
			timerInitStructure.TIM_RepetitionCounter = 0;
			TIM_TimeBaseInit(TIM2, &timerInitStructure);
			TIM_Cmd(TIM2, ENABLE);
		break;
		case 3:
			RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);
			timerInitStructure.TIM_Prescaler = prescaler;
			timerInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
			timerInitStructure.TIM_Period = periodo;
			timerInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
			timerInitStructure.TIM_RepetitionCounter = 0;
			TIM_TimeBaseInit(TIM3, &timerInitStructure);
			TIM_Cmd(TIM3, ENABLE);
		break;
		default: break;
		}
}

void TIMER_interrupt_Enable(int timer, uint16_t evento)
{
    NVIC_InitTypeDef nvicStructure;
	switch(timer)
		{
		case 1: nvicStructure.NVIC_IRQChannel = TIM1_UP_IRQn;
		TIM_ITConfig(TIM1, evento, ENABLE);
		break;
		case 2: nvicStructure.NVIC_IRQChannel = TIM2_IRQn;
		TIM_ITConfig(TIM2, evento, ENABLE);
		break;
		case 3: nvicStructure.NVIC_IRQChannel = TIM3_IRQn;
		TIM_ITConfig(TIM3, evento, ENABLE);
		break;
		case 4: nvicStructure.NVIC_IRQChannel = TIM4_IRQn;
		TIM_ITConfig(TIM4, evento, ENABLE);
		break;
		default:break;
		}
    nvicStructure.NVIC_IRQChannelPreemptionPriority = 0;
    nvicStructure.NVIC_IRQChannelSubPriority = 0;
    nvicStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&nvicStructure);
}
