/*
 * MyEP_STM32F103_UART.c
 *
 *  Created on: 19 nov. 2018
 *      Author: MyEP
 */
/*
 Utiliza funcin sprintf para impresin formateada sobre cadena USART_Stream
 y USART_puts(int NroUART, &USART_Stream) para transmitir cadena por la UART elegida

 	 	USART1		USART2		USART3
 Tx -- 	PORTA_9		PORTA_2		PORTB_10
 Rx -- 	PORTA_10	PORTA_3		PORTB_11

*/

#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_usart.h"
#include "MyEP_STM32F103_UART.h"
#include "misc.h"


void UART_interrupt_RX_init(int UART)
{
	NVIC_InitTypeDef NVIC_InitStructure;
	switch(UART)
	{
		case 1:
		USART_ITConfig(USART1, USART_IT_RXNE, ENABLE); // enable the USART1 receive interrupt
		NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;		 // we want to configure the USART1 interrupts
		break;
		case 2:
		USART_ITConfig(USART2, USART_IT_RXNE, ENABLE); // enable the USART1 receive interrupt
		NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;		 // we want to configure the USART1 interrupts
		break;
		case 3:
		USART_ITConfig(USART3, USART_IT_RXNE, ENABLE); // enable the USART1 receive interrupt
		NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;		 // we want to configure the USART1 interrupts
		break;
	}
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;// this sets the priority group of the USART1 interrupts
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;		 // this sets the subpriority inside the group
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			 // the USART1 interrupts are globally enabled
	NVIC_Init(&NVIC_InitStructure);							 // the properties are passed to the NVIC_Init function which takes care of the low level stuff
	// finally this enables the complete USART1 peripheral
}
void UART_init(int UARTn, int BaudRate, int RxInterr, int TxInterr)  //(USART_TypeDef *)
{

  GPIO_InitTypeDef GPIO_InitStructure;
  USART_InitTypeDef USART_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;

  switch (UARTn)
  {
  case 1:
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_USART1, ENABLE);
	break;
  case 2:
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);
	break;
  case 3:
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);
    break;

  default:break;
  }
  /* Configure USART Tx as alternate function  */


  switch (UARTn)
  {
  case 1:
	  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
	  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	  GPIO_Init(GPIOA, &GPIO_InitStructure);
	  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	  GPIO_Init(GPIOA, &GPIO_InitStructure);
	  break;
  case 2:
	  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
	  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	  GPIO_Init(GPIOA, &GPIO_InitStructure);
	  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
	  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	  GPIO_Init(GPIOA, &GPIO_InitStructure);
	  break;
  case 3:
	  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	  GPIO_Init(GPIOB, &GPIO_InitStructure);
	  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
	  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	  GPIO_Init(GPIOB, &GPIO_InitStructure);
	  break;
  default:break;
  }
  USART_InitStructure.USART_BaudRate = BaudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;


  /* USART configuration */
  switch(UARTn)
  {
  case 1:
	  USART_Init(USART1, &USART_InitStructure);
	  if (RxInterr)
      {
	  USART_ITConfig(USART1, USART_IT_RXNE, ENABLE); // enable the USART1 receive interrupt
	  NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;		 // we want to configure the USART1 interrupts
      NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;// this sets the priority group of the USART1 interrupts
	  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;		 // this sets the subpriority inside the group
	  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			 // the USART1 interrupts are globally enabled
	  NVIC_Init(&NVIC_InitStructure);
      }
	  /* Enable USART */
	  USART_Cmd(USART1, ENABLE);
	  break;
  case 2:
	  USART_Init(USART2, &USART_InitStructure);
	  if (RxInterr)
      {
	  USART_ITConfig(USART2, USART_IT_RXNE, ENABLE); // enable the USART1 receive interrupt
	  NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;		 // we want to configure the USART1 interrupts
      NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;// this sets the priority group of the USART1 interrupts
	  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;		 // this sets the subpriority inside the group
	  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			 // the USART1 interrupts are globally enabled
	  NVIC_Init(&NVIC_InitStructure);
      }
	  /* Enable USART */
	  USART_Cmd(USART2, ENABLE);
	  break;
  case 3:
	  USART_Init(USART3, &USART_InitStructure);
	  if (RxInterr)
      {
	  USART_ITConfig(USART3, USART_IT_RXNE, ENABLE); // enable the USART1 receive interrupt
	  NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;		 // we want to configure the USART1 interrupts
      NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;// this sets the priority group of the USART1 interrupts
	  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;		 // this sets the subpriority inside the group
	  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			 // the USART1 interrupts are globally enabled
	  NVIC_Init(&NVIC_InitStructure);
      }
	  /* Enable USART */
	  USART_Cmd(USART3, ENABLE);
	  break;
  default: break;
  }

}

int USART_puts(USART_TypeDef* UART, char *F)
{
	int c=0;
	while (*F!=0)
	{
	  USART_SendData(UART, (uint8_t) *F++);
	  while (USART_GetFlagStatus(UART, USART_FLAG_TC) == RESET)
	  {}
	  c++;
	}
	return c;
}

//char  USART3_Output(char c,char* F)
int USART_putc(USART_TypeDef* UART, char c)
{
	  USART_SendData(UART, (uint8_t) c);
	  while (USART_GetFlagStatus(UART, USART_FLAG_TC) == RESET)
	  {}
	  return c;
}


//char USART_getc(uint32_t UART)
int USART_getc(USART_TypeDef* UARTx)
{
	while(USART_GetFlagStatus(UARTx, USART_IT_RXNE)== RESET)
		{};
		int t = UARTx->DR;
		return t;
}



